Generic Image Library: Performance overloads of STL algorithms

Modules | Alphabetical List | Class List | Directories | File List | GIL Home Page

# Performance overloads of STL algorithms
[Algorithms and Utility Functions]

## Detailed Description

overloads of STL algorithms allowing more efficient implementation when used with GIL constructs

## Functions

template<typename T, typename Cs>
GIL_FORCEINLINE boost::gil::pixel< T, Cs > * | copy (boost::gil::pixel< T, Cs > *first, boost::gil::pixel< T, Cs > *last, boost::gil::pixel< T, Cs > *dst)
| Copy when both src and dst are interleaved and of the same type can be just memmove.
template<typename T, typename Cs>
GIL_FORCEINLINE boost::gil::pixel< T, Cs > * | copy (const boost::gil::pixel< T, Cs > *first, const boost::gil::pixel< T, Cs > *last, boost::gil::pixel< T, Cs > *dst)
| Copy when both src and dst are interleaved and of the same type can be just memmove.
template<typename Cs, typename IC1, typename IC2>
GIL_FORCEINLINE boost::gil::planar_pixel_iterator < IC2, Cs > | copy (boost::gil::planar_pixel_iterator< IC1, Cs > first, boost::gil::planar_pixel_iterator< IC1, Cs > last, boost::gil::planar_pixel_iterator< IC2, Cs > dst)
| Copy when both src and dst are planar pointers is copy for each channel.
template<typename IL, typename OL>
GIL_FORCEINLINE boost::gil::iterator_from_2d < OL > | copy1 (boost::gil::iterator_from_2d< IL > first, boost::gil::iterator_from_2d< IL > last, boost::gil::iterator_from_2d< OL > dst)
| std::copy(I1,I1,I2) with I1 and I2 being a iterator_from_2d
template<typename IL, typename V>
void | fill (boost::gil::iterator_from_2d< IL > first, boost::gil::iterator_from_2d< IL > last, const V &val)
| std::fill(I,I,V) with I being a iterator_from_2d
template<typename Loc1, typename Loc2>
GIL_FORCEINLINE bool | equal (boost::gil::iterator_from_2d< Loc1 > first, boost::gil::iterator_from_2d< Loc1 > last, boost::gil::iterator_from_2d< Loc2 > first2)
| std::equal(I1,I1,I2) with I1 and I2 being a iterator_from_2d

## Function Documentation

GIL_FORCEINLINE bool std::equal | ( | boost::gil::iterator_from_2d< Loc1 > | first,
|  | boost::gil::iterator_from_2d< Loc1 > | last,
|  | boost::gil::iterator_from_2d< Loc2 > | first2 |
| ) |  |  | `[inline]`

std::equal(I1,I1,I2) with I1 and I2 being a iterator_from_2d

Invoked when one calls std::equal(I1,I1,I2) with I1 and I2 being a iterator_from_2d (which is a 1D iterator over the pixels in an image). Attempts to demote the source and destination iterators to simpler/faster types if the corresponding range is contiguous. For contiguous images (i.e. images that have no alignment gap at the end of each row) it is more efficient to use the underlying pixel iterator that does not check for the end of rows. If the underlying pixel iterator happens to be a fundamental planar/interleaved pointer, the call may further resolve to memcmp. Otherwise it resolves to copying each row using the underlying pixel iterator

void std::fill | ( | boost::gil::iterator_from_2d< IL > | first,
|  | boost::gil::iterator_from_2d< IL > | last,
|  | const V & | val |
| ) |  |  | `[inline]`

std::fill(I,I,V) with I being a iterator_from_2d

Invoked when one calls std::fill(I,I,V) with I being a iterator_from_2d (which is a 1D iterator over the pixels in an image). For contiguous images (i.e. images that have no alignment gap at the end of each row) it is more efficient to use the underlying pixel iterator that does not check for the end of rows. For non-contiguous images fill resolves to fill of each row using the underlying pixel iterator, which is still faster